 #include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <errno.h>

#include <fcntl.h>
#include <sys/ioctl.h>
#include <stdint.h>

#include <SDL/SDL.h>
#include <SDL/SDL_ttf.h>

bool quit=false;
TTF_Font* font;
FILE *file;

void handleSDLEvent(SDL_Event* event)
{
    switch(event->type)
    {
    case SDL_QUIT:
        quit=true;
        break;

    // keys input
    case SDL_JOYBUTTONDOWN:
        {
            switch(event->jbutton.button)
            {
            case 8:
                quit=true;
                break;
            }
        }
        break;
	}
}

void drawText(SDL_Surface* screen, char* string, int x, int y, int fR, int fG, int fB)
{
	SDL_Color foregroundColor = { fR, fG, fB };
	SDL_Surface* textSurface =  TTF_RenderText_Blended(font,string, foregroundColor);
	SDL_Rect textLocation = { x, y, 0, 0 };
	SDL_BlitSurface(textSurface, NULL, screen, &textLocation);
	SDL_FreeSurface(textSurface);
}

typedef struct {
    uint16_t               pressure;
    uint16_t              x;
    uint16_t               y;
    uint16_t               pad;
    struct timeval  stamp;
} TS_EVENT;


int main (int argc, char **argv) {
int fd;
char Tekst[1024];
SDL_Event event;
TS_EVENT ts_event;
SDL_Surface *screen;
// init sdl
	if(SDL_Init(SDL_INIT_JOYSTICK | SDL_INIT_VIDEO | SDL_INIT_AUDIO | SDL_INIT_TIMER)<0)
	{
		fprintf(stderr,"Couldn't initialize SDL");
	}
	// setup screen
	screen = SDL_SetVideoMode( 320,240,16, SDL_SWSURFACE );
	if(!screen)
	{
		fprintf(stderr,"Couldn't set video mode");
	}

	SDL_JoystickOpen(0);

    TTF_Init();
	font = TTF_OpenFont("./arial.ttf",12);


    fd = open( "/dev/touchscreen/wm97xx", O_RDONLY | O_NOCTTY );
    if (fd)
    {

        while(!quit)
        {
            while(SDL_PollEvent(&event))
                handleSDLEvent(&event);
            read(fd, &ts_event, sizeof(TS_EVENT));

            //use the first frame to calibrate the touchscreen
            static bool autocalib=true;
            static int calibX=0, calibY=0;
            if (autocalib&&ts_event.pressure==0)
            {
                //these are experimental values from some calibrations and tries
                //not pixel perfect, so i divide by 4 to give less importance to it
                //and possibly have a minor range of error on different gp2xs
                calibX = ((ts_event.x-200)*320/3750)/4;
                calibY = (((ts_event.y-200)*240/3750))/4;
                autocalib=false;
            }

            //store screen coords
            static int x=0, y=0;

            //convert touchscreen coords to screen coords
            x = ((ts_event.x-200)*320/3750)-calibX;
            y = (240 - ((ts_event.y-200)*240/3750))-calibY;

            if (ts_event.pressure>0)
            sprintf(Tekst,"X:%d,Y:%d,pressure:%d,pad:%d",x,y,ts_event.pressure,ts_event.pad);
            else
            sprintf(Tekst,"Touchscreen not pressed");
            // background
            SDL_FillRect(screen,NULL,SDL_MapRGB(screen->format,0xFF,0xFF,0xFF));

            drawText(screen,Tekst,0,10,0,0,0);

            if(SDL_Flip(screen)<0)
            {
                fprintf(stderr,"SDL_Flip failed");
            }
        }

    }
    else
        printf("coudln't open /dev/touchscreen/wm97xxx\n");

    SDL_FreeSurface(screen);
	TTF_CloseFont(font);
	SDL_Quit();
    exit(0);
}
